//	TorusGames-2D.vs
//
//	© 2013 by Jeff Weeks
//	See TermsOfUse.txt

in vec4			atrTransformationX,	//	the "model transformation"
				atrTransformationY;
uniform vec4	uniViewTransformation;	//	(sx, sy, ∆x, ∆y) defines view transformation
										//	
										//		         ( sx   0   0 )
										//		(x, y, 1)(  0  sy   0 )
										//		         ( ∆x  ∆y   1 )

in vec3			atrPosition;	//	(x, y, c) where c is the "endcap coordinate" described
								//		at the top of TorusGamesRectangleWithEndcaps.c

#ifdef USE_TEXTURE
in vec2			atrTextureCoordinates;
in vec4			atrTextureCoordTransform;
out vec2		varTextureCoordinates;
#endif

#ifdef USE_COLOR
in vec4			atrColor;	//	premultiplied alpha
out vec4		varColor;	//	premultiplied alpha
#endif

void main()
{
	float	tmpX,
			tmpY;
	
	tmpX = dot(atrTransformationX, vec4(atrPosition, 1.0));
	tmpY = dot(atrTransformationY, vec4(atrPosition, 1.0));

	gl_Position = vec4(	uniViewTransformation[0]*tmpX + uniViewTransformation[2],
						uniViewTransformation[1]*tmpY + uniViewTransformation[3],
						0.0,
						1.0);

#ifdef USE_TEXTURE
	varTextureCoordinates = atrTextureCoordTransform.xy * atrTextureCoordinates
						  + atrTextureCoordTransform.zw;
#endif

#ifdef USE_COLOR
	varColor = atrColor;
#endif
}
